/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             V1.8     080922
 *
 *                        'T L S F _ M a R T E _ i n i t'
 *
 *                                      C
 *
 * File 'TLSF_marte_init.c'                                           By MAR.
 *
 * Defines the array 'dynamic_memory_pool' and function
 * 'init_dynamic_memory()' to be called during MaRTE OS initialization.
 *
 * --------------------------------------------------------------------------*/
#include <sys/marte_configuration_parameters.h>
#ifdef USE_TLSF_MEMORY_ALLOCATOR
#if MARTE_ARCHITECTURE != ARCH_LINUX_LIB

#include <string.h> // to avoid implicit declaration of function `memset'
#include "marte_malloc.h"

/*------------------------------*
 *--  Pool of dynamic memory  --*
 *------------------------------*/
char dynamic_memory_pool [DYNAMIC_MEMORY_POOL_SIZE_IN_K * 1024];


/*------------------------------*
 *--  init_dynamic_memory ()  --*
 *------------------------------*/
int init_dynamic_memory ()
{
  int ret;
  // memset(ptr_mem, 0x00, max_size * 1024);

  if ((ret = init_memory_pool (0,
			       TLSF_MAX_SL_LOG2_INDEX, 
			       DYNAMIC_MEMORY_POOL_SIZE_IN_K,
			       dynamic_memory_pool)) < 0) return -1;

  // associate buffer allows using directly malloc and free
  // functions instead of rtl_malloc_ex and rtl_free_ex
  associate_buffer (dynamic_memory_pool);
  return ret;
}

#endif // MARTE_ARCHITECTURE != ARCH_LINUX_LIB
#endif // USE_TLSF_MEMORY_ALLOCATOR 
