------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.8     080922
--
--                        'D e b u g _ M e s s a g e s'
--
--                                  Spec
--
--
--  File 'debug_messages.ads'                                         By MAR.
--
--
--  Configuration of the debug messages written for the kernel.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2008, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

package MaRTE.Debug_Messages is
   pragma Preelaborate;

   ----------------------
   -- General Messages --
   ----------------------
   Scheduler_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Scheduler' messages.

   Condition_Variables_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Condition_Variables' messages.

   Mutexes_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Mutexes' messages.

   Signals_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Signals' messages.

   Timed_Events_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Timed_Events_And_Timer' messages.

   Timed_Events_Queue_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Timed_Events_Queue' messages.

   Tasks_Operations_Debug_Messages : constant Boolean := False;
   --  Enable or disable the 'Tasks_Operations' messages.

   subtype TLSF_Dynamic_Memory_Debug_Messages is Boolean range True .. True;
   --  Enable or disable the debug messages produced by the TLSF
   --  dynamic memory allocator.

   subtype Register_Active_TCBs is Boolean range False .. False;
   --  Enable Active TCBs register in 'Kernel.Pool_TCBs.Debug'.

   ---------------------
   --  Task Inspector --
   ---------------------
   Tasks_Inspector_Messages : constant Boolean := False;
   --  Enable or disable the messages for the task inspector tool.

   Tasks_Inspector_Serial_Port : constant := 1; --  1 = Com1; 2 = Com2
   --  Serial port used to send the messages using the operations in
   --  the 'Tasks_Inspector' package.

end MaRTE.Debug_Messages;
