------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.8     080922
--
--                            'M a R T E _ O S '
--
--                                  Spec
--
--
--  File 'marte_os.ads'                                               By MAR.
--
--  This package must be "withed" by any MaRTE OS Ada application. It
--  is necessary to force elaboration of MaRTE kernel, otherwise
--  dependencies of GNARL on MaRTE packages are not followed by binder
--  and they are not elaborated.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2008, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

--  Packages "withed" by GNARL
with MaRTE.POSIX_Constants;
with MaRTE.HAL;
with MaRTE.Direct_IO;
with MaRTE.Kernel.Group_Clocks.Internals;
with MaRTE.Kernel.Mutexes;
with MaRTE.Kernel.Task_Sets.Operations;
with MaRTE.Kernel.Tasks_Operations.Attributes;
with MaRTE.Kernel.Tasks_Operations.Nanosleep_Gnat;
with MaRTE.Kernel.Signals.Handler;
with MaRTE.Kernel.Signals.POSIX_Functions;
with MaRTE.Stacks_Management;
with MaRTE.POSIX_Pthread;
with MaRTE.POSIX_Sched;
with MaRTE.POSIX_Signal;
with MaRTE.POSIX_Time;

--  Devices initialization
with MaRTE.Kernel.Devices_Table;
with MaRTE.Kernel.Initialization;
pragma Elaborate_All (MaRTE.Kernel.Initialization);

package MaRTE_OS is
end MaRTE_OS;
