
with Marte_Os;
with Ada.Text_Io;
use Ada.Text_Io;

with MaRTE.Integer_Types;

with Pcm3718;
use Pcm3718;
with Pcm3718_Buffer;

procedure Test_Pcm3718_Buffer is

   package Bit renames MaRTE.Integer_Types;

   procedure Pause is
      H : Character;
   begin
      Ada.Text_Io.Put("Press..");
      Ada.Text_Io.Get_Immediate(H);
      Ada.Text_Io.New_Line;
   end Pause;

   Byte_Low  : Bit.Unsigned_8;
   Byte_High : Bit.Unsigned_8;
   Datos     : Analog_Data (1 .. 256);
   C         : Num_Conv_Type;

begin

   Pcm3718_Buffer.Flush;
   -- test one data
   Put_Line("This is the Pcm3718_Buffer test program.");
   Put_Line("1- Test one data.");
   Pause;
   Byte_Low  := 2#0000_0100#; -- channel 4
   Byte_High := 2#0000_0001#; -- sample 10000=16
   Pcm3718_Buffer.Write(Byte_Low,Byte_High);
   Pcm3718_Buffer.Read(Datos,C);
   Put_Line("Datos(1).The_Channel:"&Channel_Type'Image(Datos(1).
         The_Channel)&
      "Datos(1).The_Sample:"&Sample_Type'Image(Datos(1).The_Sample)&
      "Count: "&Num_Conv_Type'Image(C)&
      "status: "&Num_Conv_Type'Image(Pcm3718_Buffer.Get_Status));
   Pause;

   -- test full buffer
   Put_Line("2- Test full buffer.");
   Pause;
   for I in 0 .. 255 loop
      Pcm3718_Buffer.Write(Byte_Low,Byte_High);
   end loop;
   Pcm3718_Buffer.Read(Datos,C);
   Put_Line("Datos(1).The_Channel:"&Channel_Type'Image(Datos(1).
         The_Channel)&
      "Datos(1).The_Sample:"&Sample_Type'Image(Datos(1).The_Sample)&
      "Count: "&Num_Conv_Type'Image(C)&
      "status: "&Num_Conv_Type'Image(Pcm3718_Buffer.Get_Status));
   Put_Line(
      "Datos(256).The_Channel:"&Channel_Type'Image(Datos(256).The_Channel)&
      "Datos(256).The_Sample:"&Sample_Type'Image(Datos(256).The_Sample)&
      "Count: "&Num_Conv_Type'Image(C)&
      "status: "&Num_Conv_Type'Image(Pcm3718_Buffer.Get_Status));
   Pause;

   -- test overwrite of buffer
   Put_Line("3- Test overwritebuffer.");
   Pause;
   for I in 1 .. 258 loop
      Pcm3718_Buffer.Write(Byte_Low,Byte_High);
   end loop;
   Pcm3718_Buffer.Read(Datos,C);
   Put_Line("Datos(1).The_Channel:"&Channel_Type'Image(Datos(1).
         The_Channel)&
      "Datos(1).The_Sample:"&Sample_Type'Image(Datos(1).The_Sample)&
      "Count: "&Num_Conv_Type'Image(C)&
      "status: "&Num_Conv_Type'Image(Pcm3718_Buffer.Get_Status));
   Put_Line(
      "Datos(256).The_Channel:"&Channel_Type'Image(Datos(256).The_Channel)&
      "Datos(256).The_Sample:"&Sample_Type'Image(Datos(256).The_Sample)&
      "Count: "&Num_Conv_Type'Image(C)&
      "status: "&Num_Conv_Type'Image(Pcm3718_Buffer.Get_Status));
   Pause;



exception
   when others =>
      Put("exceptiooooooooooooooon");
end Test_Pcm3718_Buffer;