with MaRTE_OS;
with Text_IO; use Text_IO;

with POSIX;
with POSIX.Signals;
with POSIX_Timers;

procedure Test_Posix is
   pragma Priority (8);

   The_Signal : constant POSIX.Signals.Signal := 10;
   Info : POSIX.Signals.Signal_Info;
   Waited_Set : POSIX.Signals.Signal_Set;
   Event : POSIX.Signals.Signal_Event;
   Timerid : POSIX_Timers.Timer_Id;
   Timerdata : POSIX_Timers.Timer_State;
   Options : POSIX_Timers.Timer_Options;
   Start_Time : Duration :=
      POSIX.To_Duration (POSIX_Timers.Get_Time (POSIX_Timers.Clock_Realtime));
begin
   --  Prepare set of signals
   POSIX.Signals.Delete_All_Signals (Waited_Set);
   POSIX.Signals.Add_Signal (Waited_Set, The_Signal);
   POSIX.Signals.Set_Notification (Event, POSIX.Signals.SIGNAL_NOTIFICATION);
   --  Create timer
   Timerid := POSIX_Timers.Create_Timer (POSIX_Timers.Clock_Realtime, Event);
   POSIX_Timers.Set_Initial (Timerdata, POSIX.To_Timespec (5, 0));
   POSIX_Timers.Set_Interval (Timerdata, POSIX.To_Timespec (5, 0));
   POSIX_Timers.Arm_Timer (Timerid, Options, Timerdata);
   --  Wait for signal
   for I in 1 .. 6 loop
      Info := POSIX.Signals.Await_Signal (Waited_Set);
      Put ("Received Signal at: ");
      Put (Duration'Image (POSIX.To_Duration (
                              POSIX_Timers.Get_Time (
                                 POSIX_Timers.Clock_Realtime)) - Start_Time));
      New_Line;
   end loop;
   Put_Line ("Main task finishes.");
end Test_Posix;
