/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             V1.8     080922
 *
 *                              'Console Switcher'
 *
 *                                      H
 *
 * File 'console_switcher.h'                                     by MAR.
 *
 * Driver that allows switching between differnet consoles (serial, text,
 * membuffer).
 *
 * ----------------------------------------------------------------------
 *  Copyright (C) 2000-2008, Universidad de Cantabria, SPAIN
 *
 *  MaRTE OS web page: http://marte.unican.es
 *  Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
 *                     Michael Gonzalez Harbour      mgh@unican.es
 *
 * MaRTE OS  is free software; you can  redistribute it and/or  modify it
 * under the terms of the GNU General Public License  as published by the
 * Free Software Foundation;  either  version 2, or (at  your option) any
 * later version.
 *
 * MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
 * WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 * MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 * General Public License for more details.
 *
 * You should have received  a  copy of  the  GNU General Public  License
 * distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 * Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 * 02111-1307, USA.
 *
 * As a  special exception, if you  link this  unit  with other  files to
 * produce an   executable,   this unit  does  not  by  itself cause  the
 * resulting executable to be covered by the  GNU General Public License.
 * This exception does  not however invalidate  any other reasons why the
 * executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
#ifndef __MARTE_OS_CONSOLE_SWITCHER_DRIVER__
#define __MARTE_OS_CONSOLE_SWITCHER_DRIVER__  1

#include <unistd.h>
#include <sys/cpp_macros.h>

CPP_BEGIN_DECLS

/*---------------------*
 *--  Ioctl commads  --*
 *---------------------*/
#define CHANGE_TO_TEXT_CONSOLE      320
#define CHANGE_TO_SERIAL_CONSOLE    321
#define CHANGE_TO_MEMBUFFER_CONSOLE 322

extern void SERIAL_CONSOLE_INIT(void);
extern void STANDARD_CONSOLE_INIT(void);
extern void MEMBUFFER_CONSOLE_INIT(void);

CPP_END_DECLS

#endif  // __MARTE_OS_CONSOLE_SWITCHER_DRIVER__
